#include <stdio.h>
#include <iostream>
#include <string>
#include "clocks.h"
#include <map>
int main()
{
   const int n=1000000;
   char buf[1000];
   std::string * k = new std::string[n];
   std::string * v = new std::string[n];
   std::string * w = new std::string[n];
   double t0,t1,dt;
   std::map <std::string, std::string>h;

   for (int i=0; i<n; i++)
   {
      sprintf(buf,"k%010d",i+1);
      k[i] = buf;
      if (i < 5 || i > n - 5)
	 std::cout << i<<" "<<k[i] << std::endl;
      sprintf(buf,"v%010d",i+1);
   }

   t0 = wallclock();

   for (int i = 0; i<n; i++)
   {
      h[k[i]] = v[i];
   }
   t1 = wallclock();
   dt = t1 - t0;

   std::cout << "C++"<<std::endl;
   std::cout << "Number of elements: "<<n<<std::endl;
   std::cout << "Creating hashtable: "<<dt<<" seconds" << std::endl;

   t0 = wallclock();
   for (int i = 0; i<n; i++)
   {
      w[i] = h[k[i]];
   }
   t1 = wallclock();
   dt = t1 - t0;
   std::cout << "Finding all elements: "<<dt<<" seconds" << std::endl;
   

   t0 = wallclock();
   for (int i = 0; i<n; i++)
   {
      h[k[i]] = v[i];
   }
   t1 = wallclock();
   dt = t1 - t0;
   std::cout << "Rewriting all elements: "<<dt<<" seconds" << std::endl;
   std::cout << "End C++"<<std::endl;

   return 0;
}

